#include <config.h>
/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"

/*
 * Copyright (c) 1996, 1998-2005, 2007-2012
 *	Todd C. Miller <Todd.Miller@courtesan.com>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Sponsored in part by the Defense Advanced Research Projects
 * Agency (DARPA) and Air Force Research Laboratory, Air Force
 * Materiel Command, USAF, under agreement number F39502-99-1-0512.
 */

#include <config.h>

#include <sys/types.h>
#include <sys/param.h>
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <stddef.h>
#else
# ifdef HAVE_STDLIB_H
#  include <stdlib.h>
# endif
#endif /* STDC_HEADERS */
#ifdef HAVE_STRING_H
# include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
# include <strings.h>
#endif /* HAVE_STRINGS_H */
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif /* HAVE_UNISTD_H */
#ifdef HAVE_INTTYPES_H
# include <inttypes.h>
#endif
#if defined(YYBISON) && defined(HAVE_ALLOCA_H) && !defined(__GNUC__)
# include <alloca.h>
#endif /* YYBISON && HAVE_ALLOCA_H && !__GNUC__ */
#include <limits.h>

#include "sudoers.h" /* XXX */
#include "parse.h"
#include "toke.h"
#include "gram.h"

/*
 * We must define SIZE_MAX for yacc's skeleton.c.
 * If there is no SIZE_MAX or SIZE_T_MAX we have to assume that size_t
 * could be signed (as it is on SunOS 4.x).
 */
#ifndef SIZE_MAX
# ifdef SIZE_T_MAX
#  define SIZE_MAX	SIZE_T_MAX
# else
#  define SIZE_MAX	INT_MAX
# endif /* SIZE_T_MAX */
#endif /* SIZE_MAX */

/*
 * Globals
 */
extern int sudolineno;
extern int last_token;
extern char *sudoers;
bool sudoers_warnings = true;
bool parse_error = false;
int errorlineno = -1;
char *errorfile = NULL;

struct defaults_list defaults;
struct userspec_list userspecs;

/*
 * Local protoypes
 */
static void  add_defaults(int, struct member *, struct defaults *);
static void  add_userspec(struct member *, struct privilege *);
static struct defaults *new_default(char *, char *, int);
static struct member *new_member(char *, int);
static struct sudo_digest *new_digest(int, const char *);

       void  yyerror(const char *);

void
yyerror(const char *s)
{
    debug_decl(yyerror, SUDO_DEBUG_PARSER)

    /* If we last saw a newline the error is on the preceding line. */
    if (last_token == COMMENT)
	sudolineno--;

    /* Save the line the first error occurred on. */
    if (errorlineno == -1) {
	errorlineno = sudolineno;
	errorfile = estrdup(sudoers);
    }
    if (sudoers_warnings && s != NULL) {
	LEXTRACE("<*> ");
#ifndef TRACELEXER
	if (trace_print == NULL || trace_print == sudoers_trace_print)
	    warningx(_(">>> %s: %s near line %d <<<"), sudoers, s, sudolineno);
#endif
    }
    parse_error = true;
    debug_return;
}

/* Line 371 of yacc.c  */
#line 191 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     COMMAND = 258,
     ALIAS = 259,
     DEFVAR = 260,
     NTWKADDR = 261,
     NETGROUP = 262,
     USERGROUP = 263,
     WORD = 264,
     DIGEST = 265,
     DEFAULTS = 266,
     DEFAULTS_HOST = 267,
     DEFAULTS_USER = 268,
     DEFAULTS_RUNAS = 269,
     DEFAULTS_CMND = 270,
     NOPASSWD = 271,
     PASSWD = 272,
     NOEXEC = 273,
     EXEC = 274,
     SETENV = 275,
     NOSETENV = 276,
     LOG_INPUT = 277,
     NOLOG_INPUT = 278,
     LOG_OUTPUT = 279,
     NOLOG_OUTPUT = 280,
     ALL = 281,
     COMMENT = 282,
     HOSTALIAS = 283,
     CMNDALIAS = 284,
     USERALIAS = 285,
     RUNASALIAS = 286,
     ERROR = 287,
     TYPE = 288,
     ROLE = 289,
     PRIVS = 290,
     LIMITPRIVS = 291,
     MYSELF = 292,
     SHA224 = 293,
     SHA256 = 294,
     SHA384 = 295,
     SHA512 = 296
   };
#endif
/* Tokens.  */
#define COMMAND 258
#define ALIAS 259
#define DEFVAR 260
#define NTWKADDR 261
#define NETGROUP 262
#define USERGROUP 263
#define WORD 264
#define DIGEST 265
#define DEFAULTS 266
#define DEFAULTS_HOST 267
#define DEFAULTS_USER 268
#define DEFAULTS_RUNAS 269
#define DEFAULTS_CMND 270
#define NOPASSWD 271
#define PASSWD 272
#define NOEXEC 273
#define EXEC 274
#define SETENV 275
#define NOSETENV 276
#define LOG_INPUT 277
#define NOLOG_INPUT 278
#define LOG_OUTPUT 279
#define NOLOG_OUTPUT 280
#define ALL 281
#define COMMENT 282
#define HOSTALIAS 283
#define CMNDALIAS 284
#define USERALIAS 285
#define RUNASALIAS 286
#define ERROR 287
#define TYPE 288
#define ROLE 289
#define PRIVS 290
#define LIMITPRIVS 291
#define MYSELF 292
#define SHA224 293
#define SHA256 294
#define SHA384 295
#define SHA512 296



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 124 "gram.y"

    struct cmndspec *cmndspec;
    struct defaults *defaults;
    struct member *member;
    struct runascontainer *runas;
    struct privilege *privilege;
    struct sudo_digest *digest;
    struct sudo_command command;
    struct cmndtag tag;
    struct selinux_info seinfo;
    struct solaris_privs_info privinfo;
    char *string;
    int tok;


/* Line 387 of yacc.c  */
#line 332 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 360 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   225

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  41
/* YYNRULES -- Number of rules.  */
#define YYNRULES  112
/* YYNRULES -- Number of states.  */
#define YYNSTATES  176

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    35,     2,     2,     2,     2,     2,     2,
      38,    39,     2,    36,    34,    37,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    32,     2,
       2,    33,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    13,    16,    19,
      22,    25,    28,    31,    34,    38,    42,    46,    50,    52,
      56,    58,    61,    65,    69,    73,    75,    79,    83,    85,
      88,    90,    92,    94,    96,    98,   100,   104,   110,   114,
     118,   122,   126,   128,   131,   133,   136,   140,   144,   145,
     147,   149,   152,   155,   159,   163,   164,   166,   168,   171,
     174,   175,   179,   180,   182,   186,   189,   191,   192,   195,
     198,   201,   204,   207,   210,   213,   216,   219,   222,   224,
     226,   228,   230,   234,   238,   240,   244,   246,   250,   254,
     256,   260,   262,   266,   270,   272,   276,   280,   282,   286,
     288,   291,   293,   295,   297,   299,   301,   303,   307,   309,
     312,   314,   316
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      51,     0,    -1,    -1,    52,    -1,    53,    -1,    52,    53,
      -1,    27,    -1,     1,    27,    -1,    85,    56,    -1,    30,
      83,    -1,    28,    75,    -1,    29,    78,    -1,    31,    81,
      -1,    11,    54,    -1,    13,    85,    54,    -1,    14,    85,
      54,    -1,    12,    77,    54,    -1,    15,    80,    54,    -1,
      55,    -1,    54,    34,    55,    -1,     5,    -1,    35,     5,
      -1,     5,    33,     9,    -1,     5,    36,     9,    -1,     5,
      37,     9,    -1,    57,    -1,    56,    32,    57,    -1,    77,
      33,    60,    -1,    59,    -1,    35,    59,    -1,     4,    -1,
      26,    -1,     7,    -1,     6,    -1,     9,    -1,    61,    -1,
      60,    34,    61,    -1,    71,    67,    70,    73,    63,    -1,
      46,    32,    10,    -1,    47,    32,    10,    -1,    48,    32,
      10,    -1,    49,    32,    10,    -1,    64,    -1,    62,    64,
      -1,    74,    -1,    35,    74,    -1,    42,    33,     9,    -1,
      41,    33,     9,    -1,    -1,    65,    -1,    66,    -1,    65,
      66,    -1,    66,    65,    -1,    43,    33,     9,    -1,    44,
      33,     9,    -1,    -1,    68,    -1,    69,    -1,    68,    69,
      -1,    69,    68,    -1,    -1,    38,    72,    39,    -1,    -1,
      85,    -1,    85,    32,    88,    -1,    32,    88,    -1,    32,
      -1,    -1,    73,    16,    -1,    73,    17,    -1,    73,    18,
      -1,    73,    19,    -1,    73,    20,    -1,    73,    21,    -1,
      73,    22,    -1,    73,    23,    -1,    73,    24,    -1,    73,
      25,    -1,    26,    -1,     4,    -1,     3,    -1,    76,    -1,
      75,    32,    76,    -1,     4,    33,    77,    -1,    58,    -1,
      77,    34,    58,    -1,    79,    -1,    78,    32,    79,    -1,
       4,    33,    80,    -1,    63,    -1,    80,    34,    63,    -1,
      82,    -1,    81,    32,    82,    -1,     4,    33,    85,    -1,
      84,    -1,    83,    32,    84,    -1,     4,    33,    85,    -1,
      86,    -1,    85,    34,    86,    -1,    87,    -1,    35,    87,
      -1,     4,    -1,    26,    -1,     7,    -1,     8,    -1,     9,
      -1,    89,    -1,    88,    34,    89,    -1,    90,    -1,    35,
      90,    -1,     4,    -1,    26,    -1,     9,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   214,   214,   215,   218,   219,   222,   225,   228,   231,
     234,   237,   240,   243,   246,   249,   252,   255,   260,   261,
     267,   270,   273,   276,   279,   284,   285,   291,   301,   305,
     311,   314,   317,   320,   323,   328,   329,   368,   398,   401,
     404,   407,   412,   415,   425,   429,   435,   440,   445,   449,
     453,   457,   461,   467,   471,   476,   480,   484,   488,   492,
     497,   500,   505,   510,   515,   520,   525,   532,   536,   539,
     542,   545,   548,   551,   554,   557,   560,   563,   568,   571,
     574,   582,   583,   586,   595,   596,   602,   603,   606,   615,
     616,   622,   623,   626,   635,   636,   639,   648,   649,   655,
     659,   665,   668,   671,   674,   677,   682,   683,   689,   693,
     699,   702,   705
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMAND", "ALIAS", "DEFVAR", "NTWKADDR",
  "NETGROUP", "USERGROUP", "WORD", "DIGEST", "DEFAULTS", "DEFAULTS_HOST",
  "DEFAULTS_USER", "DEFAULTS_RUNAS", "DEFAULTS_CMND", "NOPASSWD", "PASSWD",
  "NOEXEC", "EXEC", "SETENV", "NOSETENV", "LOG_INPUT", "NOLOG_INPUT",
  "LOG_OUTPUT", "NOLOG_OUTPUT", "ALL", "COMMENT", "HOSTALIAS", "CMNDALIAS",
  "USERALIAS", "RUNASALIAS", "':'", "'='", "','", "'!'", "'+'", "'-'",
  "'('", "')'", "ERROR", "TYPE", "ROLE", "PRIVS", "LIMITPRIVS", "MYSELF",
  "SHA224", "SHA256", "SHA384", "SHA512", "$accept", "file", "line",
  "entry", "defaults_list", "defaults_entry", "privileges", "privilege",
  "ophost", "host", "cmndspeclist", "cmndspec", "digest", "digcmnd",
  "opcmnd", "rolespec", "typespec", "selinux", "privsspec",
  "limitprivsspec", "solarisprivs", "runasspec", "runaslist", "cmndtag",
  "cmnd", "hostaliases", "hostalias", "hostlist", "cmndaliases",
  "cmndalias", "cmndlist", "runasaliases", "runasalias", "useraliases",
  "useralias", "userlist", "opuser", "user", "grouplist", "opgroup",
  "group", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    58,    61,    44,    33,    43,    45,    40,    41,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    50,    51,    51,    52,    52,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    54,    54,
      55,    55,    55,    55,    55,    56,    56,    57,    58,    58,
      59,    59,    59,    59,    59,    60,    60,    61,    62,    62,
      62,    62,    63,    63,    64,    64,    65,    66,    67,    67,
      67,    67,    67,    68,    69,    70,    70,    70,    70,    70,
      71,    71,    72,    72,    72,    72,    72,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    74,    74,
      74,    75,    75,    76,    77,    77,    78,    78,    79,    80,
      80,    81,    81,    82,    83,    83,    84,    85,    85,    86,
      86,    87,    87,    87,    87,    87,    88,    88,    89,    89,
      90,    90,    90
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     1,     3,
       1,     2,     3,     3,     3,     1,     3,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     3,     5,     3,     3,
       3,     3,     1,     2,     1,     2,     3,     3,     0,     1,
       1,     2,     2,     3,     3,     0,     1,     1,     2,     2,
       0,     3,     0,     1,     3,     2,     1,     0,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     3,     3,     1,     3,     1,     3,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     1,     3,     1,
       2,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,   101,   103,   104,   105,     0,     0,     0,     0,
       0,   102,     6,     0,     0,     0,     0,     0,     0,     0,
       4,     0,    97,    99,     7,    20,     0,    13,    18,    30,
      33,    32,    34,    31,     0,    84,    28,     0,     0,     0,
      80,    79,    78,     0,     0,     0,     0,     0,     0,    89,
      42,    44,     0,     0,    10,    81,     0,    11,    86,     0,
       9,    94,     0,    12,    91,   100,     1,     5,     0,     8,
      25,     0,     0,     0,     0,    21,     0,    29,     0,    16,
      14,    15,    45,     0,     0,     0,     0,    43,     0,    17,
       0,     0,     0,     0,     0,     0,     0,     0,    98,     0,
      60,    22,    23,    24,    19,    85,    38,    39,    40,    41,
      90,    83,    82,    88,    87,    96,    95,    93,    92,    26,
      62,    27,    35,    48,    66,     0,    63,    60,     0,     0,
      49,    50,    55,   110,   112,   111,     0,    65,   106,   108,
      61,     0,    36,     0,     0,    51,    52,     0,     0,    56,
      57,    67,   109,     0,    64,    47,    46,     0,     0,    58,
      59,     0,   107,    53,    54,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    37
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    18,    19,    20,    27,    28,    69,    70,    35,    36,
     121,   122,    48,    49,    50,   130,   131,   132,   149,   150,
     151,   123,   125,   161,    51,    54,    55,    71,    57,    58,
      52,    63,    64,    60,    61,    21,    22,    23,   137,   138,
     139
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -86
static const yytype_int16 yypact[] =
{
      66,     8,   -86,   -86,   -86,   -86,    29,    56,   134,   134,
       5,   -86,   -86,    26,    28,    33,    39,   144,    46,   102,
     -86,     7,   -86,   -86,   -86,   121,    54,    27,   -86,   -86,
     -86,   -86,   -86,   -86,   155,   -86,   -86,    10,    23,    23,
     -86,   -86,   -86,   101,    55,    57,    58,    67,     3,   -86,
     -86,   -86,    34,    65,    68,   -86,    74,    76,   -86,    86,
      88,   -86,    91,    93,   -86,   -86,   -86,   -86,   134,    94,
     -86,    22,   126,   127,   138,   -86,    29,   -86,    56,    27,
      27,    27,   -86,   145,   153,   156,   158,   -86,     5,    27,
      56,    26,     5,    28,   134,    33,   134,    39,   -86,    56,
     106,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   137,   -86,   142,   -86,   143,   -86,   143,   -86,   -86,
     114,   146,   -86,    30,   130,   136,   -22,   106,   149,   150,
     147,   148,    40,   -86,   -86,   -86,   141,   151,   -86,   -86,
     -86,   130,   -86,   169,   170,   -86,   -86,   159,   160,   140,
     152,   -86,   -86,   130,   151,   -86,   -86,   177,   180,   -86,
     -86,     1,   -86,   -86,   -86,   -86,   -86,   -86,   -86,   -86,
     -86,   -86,   -86,   -86,   -86,   -86
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -86,   -86,   -86,   172,   135,   118,   -86,    97,   119,   164,
     -86,    72,   -86,   -85,   154,    69,    71,   -86,    53,    59,
     -86,   -86,   -86,   -86,   161,   -86,   115,    -5,   -86,   112,
     117,   -86,   110,   -86,   116,    -8,   157,   193,    73,    60,
      79
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -4
static const yytype_int16 yytable[] =
{
      38,    39,    37,   110,    40,    41,    40,    41,    40,    41,
     141,    29,    68,    30,    31,    25,    32,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,    42,    25,    42,
      53,    42,    56,    33,    25,    24,    43,    59,    43,    25,
      43,    68,    34,    62,    78,    26,    66,    44,    45,    46,
      47,    44,    45,    46,    47,   100,    78,    68,    26,    75,
      29,    76,    30,    31,    26,    32,    -2,     1,    88,    26,
       2,   128,   129,     3,     4,     5,   175,     6,     7,     8,
       9,    10,    33,   147,   148,   111,   115,    83,   117,    84,
      85,    34,    11,    12,    13,    14,    15,    16,    90,    86,
      91,    17,    -3,     1,    40,    41,     2,    92,    93,     3,
       4,     5,   126,     6,     7,     8,     9,    10,     2,    94,
      95,     3,     4,     5,    96,    97,    99,    42,    11,    12,
      13,    14,    15,    16,   133,   101,   102,    17,     2,   134,
      11,     3,     4,     5,   120,   133,   124,   103,     2,    17,
     134,     3,     4,     5,    72,   106,   135,    73,    74,    29,
      11,    30,    31,   107,    32,   136,   108,   135,   109,    17,
      11,    78,    79,    80,    81,   140,    88,    68,   155,   156,
     127,    33,   143,   144,   148,   153,   163,    89,   128,   164,
     129,    67,   157,   158,   104,   147,   119,   105,    77,   142,
     146,   145,    87,   160,    82,   114,   112,   118,   159,   113,
      65,   116,     0,   162,   154,   152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    98
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-86)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       8,     9,     7,    88,     3,     4,     3,     4,     3,     4,
      32,     4,    34,     6,     7,     5,     9,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,     5,    26,
       4,    26,     4,    26,     5,    27,    35,     4,    35,     5,
      35,    34,    35,     4,    34,    35,     0,    46,    47,    48,
      49,    46,    47,    48,    49,    33,    34,    34,    35,     5,
       4,    34,     6,     7,    35,     9,     0,     1,    34,    35,
       4,    41,    42,     7,     8,     9,   161,    11,    12,    13,
      14,    15,    26,    43,    44,    90,    94,    32,    96,    32,
      32,    35,    26,    27,    28,    29,    30,    31,    33,    32,
      32,    35,     0,     1,     3,     4,     4,    33,    32,     7,
       8,     9,   120,    11,    12,    13,    14,    15,     4,    33,
      32,     7,     8,     9,    33,    32,    32,    26,    26,    27,
      28,    29,    30,    31,     4,     9,     9,    35,     4,     9,
      26,     7,     8,     9,    38,     4,    32,     9,     4,    35,
       9,     7,     8,     9,    33,    10,    26,    36,    37,     4,
      26,     6,     7,    10,     9,    35,    10,    26,    10,    35,
      26,    34,    37,    38,    39,    39,    34,    34,     9,     9,
      34,    26,    33,    33,    44,    34,     9,    52,    41,     9,
      42,    19,    33,    33,    76,    43,    99,    78,    34,   127,
     131,   130,    48,   150,    43,    93,    91,    97,   149,    92,
      17,    95,    -1,   153,   141,   136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     4,     7,     8,     9,    11,    12,    13,    14,
      15,    26,    27,    28,    29,    30,    31,    35,    51,    52,
      53,    85,    86,    87,    27,     5,    35,    54,    55,     4,
       6,     7,     9,    26,    35,    58,    59,    77,    85,    85,
       3,     4,    26,    35,    46,    47,    48,    49,    62,    63,
      64,    74,    80,     4,    75,    76,     4,    78,    79,     4,
      83,    84,     4,    81,    82,    87,     0,    53,    34,    56,
      57,    77,    33,    36,    37,     5,    34,    59,    34,    54,
      54,    54,    74,    32,    32,    32,    32,    64,    34,    54,
      33,    32,    33,    32,    33,    32,    33,    32,    86,    32,
      33,     9,     9,     9,    55,    58,    10,    10,    10,    10,
      63,    77,    76,    80,    79,    85,    84,    85,    82,    57,
      38,    60,    61,    71,    32,    72,    85,    34,    41,    42,
      65,    66,    67,     4,     9,    26,    35,    88,    89,    90,
      39,    32,    61,    33,    33,    66,    65,    43,    44,    68,
      69,    70,    90,    34,    88,     9,     9,    33,    33,    69,
      68,    73,    89,     9,     9,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    63
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 214 "gram.y"
    { ; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 222 "gram.y"
    {
			    ;
			}
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 225 "gram.y"
    {
			    yyerrok;
			}
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 228 "gram.y"
    {
			    add_userspec((yyvsp[(1) - (2)].member), (yyvsp[(2) - (2)].privilege));
			}
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 231 "gram.y"
    {
			    ;
			}
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 234 "gram.y"
    {
			    ;
			}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 237 "gram.y"
    {
			    ;
			}
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 240 "gram.y"
    {
			    ;
			}
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 243 "gram.y"
    {
			    add_defaults(DEFAULTS, NULL, (yyvsp[(2) - (2)].defaults));
			}
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 246 "gram.y"
    {
			    add_defaults(DEFAULTS_USER, (yyvsp[(2) - (3)].member), (yyvsp[(3) - (3)].defaults));
			}
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 249 "gram.y"
    {
			    add_defaults(DEFAULTS_RUNAS, (yyvsp[(2) - (3)].member), (yyvsp[(3) - (3)].defaults));
			}
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 252 "gram.y"
    {
			    add_defaults(DEFAULTS_HOST, (yyvsp[(2) - (3)].member), (yyvsp[(3) - (3)].defaults));
			}
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 255 "gram.y"
    {
			    add_defaults(DEFAULTS_CMND, (yyvsp[(2) - (3)].member), (yyvsp[(3) - (3)].defaults));
			}
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 261 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].defaults), (yyvsp[(3) - (3)].defaults));
			    (yyval.defaults) = (yyvsp[(1) - (3)].defaults);
			}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 267 "gram.y"
    {
			    (yyval.defaults) = new_default((yyvsp[(1) - (1)].string), NULL, true);
			}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 270 "gram.y"
    {
			    (yyval.defaults) = new_default((yyvsp[(2) - (2)].string), NULL, false);
			}
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 273 "gram.y"
    {
			    (yyval.defaults) = new_default((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string), true);
			}
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 276 "gram.y"
    {
			    (yyval.defaults) = new_default((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string), '+');
			}
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 279 "gram.y"
    {
			    (yyval.defaults) = new_default((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string), '-');
			}
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 285 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].privilege), (yyvsp[(3) - (3)].privilege));
			    (yyval.privilege) = (yyvsp[(1) - (3)].privilege);
			}
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 291 "gram.y"
    {
			    struct privilege *p = ecalloc(1, sizeof(*p));
			    list2tq(&p->hostlist, (yyvsp[(1) - (3)].member));
			    list2tq(&p->cmndlist, (yyvsp[(3) - (3)].cmndspec));
			    p->prev = p;
			    /* p->next = NULL; */
			    (yyval.privilege) = p;
			}
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 301 "gram.y"
    {
			    (yyval.member) = (yyvsp[(1) - (1)].member);
			    (yyval.member)->negated = false;
			}
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 305 "gram.y"
    {
			    (yyval.member) = (yyvsp[(2) - (2)].member);
			    (yyval.member)->negated = true;
			}
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 311 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), ALIAS);
			}
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 314 "gram.y"
    {
			    (yyval.member) = new_member(NULL, ALL);
			}
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 317 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), NETGROUP);
			}
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 320 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), NTWKADDR);
			}
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 323 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), WORD);
			}
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 329 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].cmndspec), (yyvsp[(3) - (3)].cmndspec));
#ifdef HAVE_SELINUX
			    /* propagate role and type */
			    if ((yyvsp[(3) - (3)].cmndspec)->role == NULL)
				(yyvsp[(3) - (3)].cmndspec)->role = (yyvsp[(3) - (3)].cmndspec)->prev->role;
			    if ((yyvsp[(3) - (3)].cmndspec)->type == NULL)
				(yyvsp[(3) - (3)].cmndspec)->type = (yyvsp[(3) - (3)].cmndspec)->prev->type;
#endif /* HAVE_SELINUX */
#ifdef HAVE_PRIV_SET
			    /* propagate privs & limitprivs */
			    if ((yyvsp[(3) - (3)].cmndspec)->privs == NULL)
			        (yyvsp[(3) - (3)].cmndspec)->privs = (yyvsp[(3) - (3)].cmndspec)->prev->privs;
			    if ((yyvsp[(3) - (3)].cmndspec)->limitprivs == NULL)
			        (yyvsp[(3) - (3)].cmndspec)->limitprivs = (yyvsp[(3) - (3)].cmndspec)->prev->limitprivs;
#endif /* HAVE_PRIV_SET */
			    /* propagate tags and runas list */
			    if ((yyvsp[(3) - (3)].cmndspec)->tags.nopasswd == UNSPEC)
				(yyvsp[(3) - (3)].cmndspec)->tags.nopasswd = (yyvsp[(3) - (3)].cmndspec)->prev->tags.nopasswd;
			    if ((yyvsp[(3) - (3)].cmndspec)->tags.noexec == UNSPEC)
				(yyvsp[(3) - (3)].cmndspec)->tags.noexec = (yyvsp[(3) - (3)].cmndspec)->prev->tags.noexec;
			    if ((yyvsp[(3) - (3)].cmndspec)->tags.setenv == UNSPEC &&
				(yyvsp[(3) - (3)].cmndspec)->prev->tags.setenv != IMPLIED)
				(yyvsp[(3) - (3)].cmndspec)->tags.setenv = (yyvsp[(3) - (3)].cmndspec)->prev->tags.setenv;
			    if ((yyvsp[(3) - (3)].cmndspec)->tags.log_input == UNSPEC)
				(yyvsp[(3) - (3)].cmndspec)->tags.log_input = (yyvsp[(3) - (3)].cmndspec)->prev->tags.log_input;
			    if ((yyvsp[(3) - (3)].cmndspec)->tags.log_output == UNSPEC)
				(yyvsp[(3) - (3)].cmndspec)->tags.log_output = (yyvsp[(3) - (3)].cmndspec)->prev->tags.log_output;
			    if ((tq_empty(&(yyvsp[(3) - (3)].cmndspec)->runasuserlist) &&
				 tq_empty(&(yyvsp[(3) - (3)].cmndspec)->runasgrouplist)) &&
				(!tq_empty(&(yyvsp[(3) - (3)].cmndspec)->prev->runasuserlist) ||
				 !tq_empty(&(yyvsp[(3) - (3)].cmndspec)->prev->runasgrouplist))) {
				(yyvsp[(3) - (3)].cmndspec)->runasuserlist = (yyvsp[(3) - (3)].cmndspec)->prev->runasuserlist;
				(yyvsp[(3) - (3)].cmndspec)->runasgrouplist = (yyvsp[(3) - (3)].cmndspec)->prev->runasgrouplist;
			    }
			    (yyval.cmndspec) = (yyvsp[(1) - (3)].cmndspec);
			}
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 368 "gram.y"
    {
			    struct cmndspec *cs = ecalloc(1, sizeof(*cs));
			    if ((yyvsp[(1) - (5)].runas) != NULL) {
				list2tq(&cs->runasuserlist, (yyvsp[(1) - (5)].runas)->runasusers);
				list2tq(&cs->runasgrouplist, (yyvsp[(1) - (5)].runas)->runasgroups);
				efree((yyvsp[(1) - (5)].runas));
			    } else {
				tq_init(&cs->runasuserlist);
				tq_init(&cs->runasgrouplist);
			    }
#ifdef HAVE_SELINUX
			    cs->role = (yyvsp[(2) - (5)].seinfo).role;
			    cs->type = (yyvsp[(2) - (5)].seinfo).type;
#endif
#ifdef HAVE_PRIV_SET
			    cs->privs = (yyvsp[(3) - (5)].privinfo).privs;
			    cs->limitprivs = (yyvsp[(3) - (5)].privinfo).limitprivs;
#endif
			    cs->tags = (yyvsp[(4) - (5)].tag);
			    cs->cmnd = (yyvsp[(5) - (5)].member);
			    cs->prev = cs;
			    cs->next = NULL;
			    /* sudo "ALL" implies the SETENV tag */
			    if (cs->cmnd->type == ALL && !cs->cmnd->negated &&
				cs->tags.setenv == UNSPEC)
				cs->tags.setenv = IMPLIED;
			    (yyval.cmndspec) = cs;
			}
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 398 "gram.y"
    {
			    (yyval.digest) = new_digest(SUDO_DIGEST_SHA224, (yyvsp[(3) - (3)].string));
			}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 401 "gram.y"
    {
			    (yyval.digest) = new_digest(SUDO_DIGEST_SHA256, (yyvsp[(3) - (3)].string));
			}
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 404 "gram.y"
    {
			    (yyval.digest) = new_digest(SUDO_DIGEST_SHA384, (yyvsp[(3) - (3)].string));
			}
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 407 "gram.y"
    {
			    (yyval.digest) = new_digest(SUDO_DIGEST_SHA512, (yyvsp[(3) - (3)].string));
			}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 412 "gram.y"
    {
			    (yyval.member) = (yyvsp[(1) - (1)].member);
			}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 415 "gram.y"
    {
			    if ((yyvsp[(2) - (2)].member)->type != COMMAND) {
				YYERROR;
			    }
			    /* XXX - yuck */
			    ((struct sudo_command *) (yyvsp[(2) - (2)].member)->name)->digest = (yyvsp[(1) - (2)].digest);
			    (yyval.member) = (yyvsp[(2) - (2)].member);
			}
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 425 "gram.y"
    {
			    (yyval.member) = (yyvsp[(1) - (1)].member);
			    (yyval.member)->negated = false;
			}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 429 "gram.y"
    {
			    (yyval.member) = (yyvsp[(2) - (2)].member);
			    (yyval.member)->negated = true;
			}
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 435 "gram.y"
    {
			    (yyval.string) = (yyvsp[(3) - (3)].string);
			}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 440 "gram.y"
    {
			    (yyval.string) = (yyvsp[(3) - (3)].string);
			}
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 445 "gram.y"
    {
			    (yyval.seinfo).role = NULL;
			    (yyval.seinfo).type = NULL;
			}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 449 "gram.y"
    {
			    (yyval.seinfo).role = (yyvsp[(1) - (1)].string);
			    (yyval.seinfo).type = NULL;
			}
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 453 "gram.y"
    {
			    (yyval.seinfo).type = (yyvsp[(1) - (1)].string);
			    (yyval.seinfo).role = NULL;
			}
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 457 "gram.y"
    {
			    (yyval.seinfo).role = (yyvsp[(1) - (2)].string);
			    (yyval.seinfo).type = (yyvsp[(2) - (2)].string);
			}
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 461 "gram.y"
    {
			    (yyval.seinfo).type = (yyvsp[(1) - (2)].string);
			    (yyval.seinfo).role = (yyvsp[(2) - (2)].string);
			}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 467 "gram.y"
    {
			    (yyval.string) = (yyvsp[(3) - (3)].string);
			}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 471 "gram.y"
    {
			    (yyval.string) = (yyvsp[(3) - (3)].string);
			}
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 476 "gram.y"
    {
			    (yyval.privinfo).privs = NULL;
			    (yyval.privinfo).limitprivs = NULL;
			}
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 480 "gram.y"
    {
			    (yyval.privinfo).privs = (yyvsp[(1) - (1)].string);
			    (yyval.privinfo).limitprivs = NULL;
			}
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 484 "gram.y"
    {
			    (yyval.privinfo).privs = NULL;
			    (yyval.privinfo).limitprivs = (yyvsp[(1) - (1)].string);
			}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 488 "gram.y"
    {
			    (yyval.privinfo).privs = (yyvsp[(1) - (2)].string);
			    (yyval.privinfo).limitprivs = (yyvsp[(2) - (2)].string);
			}
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 492 "gram.y"
    {
			    (yyval.privinfo).limitprivs = (yyvsp[(1) - (2)].string);
			    (yyval.privinfo).privs = (yyvsp[(2) - (2)].string);
			}
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 497 "gram.y"
    {
			    (yyval.runas) = NULL;
			}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 500 "gram.y"
    {
			    (yyval.runas) = (yyvsp[(2) - (3)].runas);
			}
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 505 "gram.y"
    {
			    (yyval.runas) = ecalloc(1, sizeof(struct runascontainer));
			    (yyval.runas)->runasusers = new_member(NULL, MYSELF);
			    /* $$->runasgroups = NULL; */
			}
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 510 "gram.y"
    {
			    (yyval.runas) = ecalloc(1, sizeof(struct runascontainer));
			    (yyval.runas)->runasusers = (yyvsp[(1) - (1)].member);
			    /* $$->runasgroups = NULL; */
			}
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 515 "gram.y"
    {
			    (yyval.runas) = ecalloc(1, sizeof(struct runascontainer));
			    (yyval.runas)->runasusers = (yyvsp[(1) - (3)].member);
			    (yyval.runas)->runasgroups = (yyvsp[(3) - (3)].member);
			}
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 520 "gram.y"
    {
			    (yyval.runas) = ecalloc(1, sizeof(struct runascontainer));
			    /* $$->runasusers = NULL; */
			    (yyval.runas)->runasgroups = (yyvsp[(2) - (2)].member);
			}
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 525 "gram.y"
    {
			    (yyval.runas) = ecalloc(1, sizeof(struct runascontainer));
			    (yyval.runas)->runasusers = new_member(NULL, MYSELF);
			    /* $$->runasgroups = NULL; */
			}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 532 "gram.y"
    {
			    (yyval.tag).nopasswd = (yyval.tag).noexec = (yyval.tag).setenv =
				(yyval.tag).log_input = (yyval.tag).log_output = UNSPEC;
			}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 536 "gram.y"
    {
			    (yyval.tag).nopasswd = true;
			}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 539 "gram.y"
    {
			    (yyval.tag).nopasswd = false;
			}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 542 "gram.y"
    {
			    (yyval.tag).noexec = true;
			}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 545 "gram.y"
    {
			    (yyval.tag).noexec = false;
			}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 548 "gram.y"
    {
			    (yyval.tag).setenv = true;
			}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 551 "gram.y"
    {
			    (yyval.tag).setenv = false;
			}
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 554 "gram.y"
    {
			    (yyval.tag).log_input = true;
			}
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 557 "gram.y"
    {
			    (yyval.tag).log_input = false;
			}
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 560 "gram.y"
    {
			    (yyval.tag).log_output = true;
			}
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 563 "gram.y"
    {
			    (yyval.tag).log_output = false;
			}
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 568 "gram.y"
    {
			    (yyval.member) = new_member(NULL, ALL);
			}
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 571 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), ALIAS);
			}
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 574 "gram.y"
    {
			    struct sudo_command *c = ecalloc(1, sizeof(*c));
			    c->cmnd = (yyvsp[(1) - (1)].command).cmnd;
			    c->args = (yyvsp[(1) - (1)].command).args;
			    (yyval.member) = new_member((char *)c, COMMAND);
			}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 586 "gram.y"
    {
			    char *s;
			    if ((s = alias_add((yyvsp[(1) - (3)].string), HOSTALIAS, (yyvsp[(3) - (3)].member))) != NULL) {
				yyerror(s);
				YYERROR;
			    }
			}
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 596 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].member), (yyvsp[(3) - (3)].member));
			    (yyval.member) = (yyvsp[(1) - (3)].member);
			}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 606 "gram.y"
    {
			    char *s;
			    if ((s = alias_add((yyvsp[(1) - (3)].string), CMNDALIAS, (yyvsp[(3) - (3)].member))) != NULL) {
				yyerror(s);
				YYERROR;
			    }
			}
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 616 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].member), (yyvsp[(3) - (3)].member));
			    (yyval.member) = (yyvsp[(1) - (3)].member);
			}
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 626 "gram.y"
    {
			    char *s;
			    if ((s = alias_add((yyvsp[(1) - (3)].string), RUNASALIAS, (yyvsp[(3) - (3)].member))) != NULL) {
				yyerror(s);
				YYERROR;
			    }
			}
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 639 "gram.y"
    {
			    char *s;
			    if ((s = alias_add((yyvsp[(1) - (3)].string), USERALIAS, (yyvsp[(3) - (3)].member))) != NULL) {
				yyerror(s);
				YYERROR;
			    }
			}
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 649 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].member), (yyvsp[(3) - (3)].member));
			    (yyval.member) = (yyvsp[(1) - (3)].member);
			}
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 655 "gram.y"
    {
			    (yyval.member) = (yyvsp[(1) - (1)].member);
			    (yyval.member)->negated = false;
			}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 659 "gram.y"
    {
			    (yyval.member) = (yyvsp[(2) - (2)].member);
			    (yyval.member)->negated = true;
			}
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 665 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), ALIAS);
			}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 668 "gram.y"
    {
			    (yyval.member) = new_member(NULL, ALL);
			}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 671 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), NETGROUP);
			}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 674 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), USERGROUP);
			}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 677 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), WORD);
			}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 683 "gram.y"
    {
			    list_append((yyvsp[(1) - (3)].member), (yyvsp[(3) - (3)].member));
			    (yyval.member) = (yyvsp[(1) - (3)].member);
			}
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 689 "gram.y"
    {
			    (yyval.member) = (yyvsp[(1) - (1)].member);
			    (yyval.member)->negated = false;
			}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 693 "gram.y"
    {
			    (yyval.member) = (yyvsp[(2) - (2)].member);
			    (yyval.member)->negated = true;
			}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 699 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), ALIAS);
			}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 702 "gram.y"
    {
			    (yyval.member) = new_member(NULL, ALL);
			}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 705 "gram.y"
    {
			    (yyval.member) = new_member((yyvsp[(1) - (1)].string), WORD);
			}
    break;


/* Line 1792 of yacc.c  */
#line 2600 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 710 "gram.y"

static struct defaults *
new_default(char *var, char *val, int op)
{
    struct defaults *d;
    debug_decl(new_default, SUDO_DEBUG_PARSER)

    d = ecalloc(1, sizeof(struct defaults));
    d->var = var;
    d->val = val;
    tq_init(&d->binding);
    /* d->type = 0; */
    d->op = op;
    d->prev = d;
    /* d->next = NULL; */

    debug_return_ptr(d);
}

static struct member *
new_member(char *name, int type)
{
    struct member *m;
    debug_decl(new_member, SUDO_DEBUG_PARSER)

    m = ecalloc(1, sizeof(struct member));
    m->name = name;
    m->type = type;
    m->prev = m;
    /* m->next = NULL; */

    debug_return_ptr(m);
}

struct sudo_digest *
new_digest(int digest_type, const char *digest_str)
{
    struct sudo_digest *dig;
    debug_decl(new_digest, SUDO_DEBUG_PARSER)

    dig = emalloc(sizeof(*dig));
    dig->digest_type = digest_type;
    dig->digest_str = estrdup(digest_str);

    debug_return_ptr(dig);
}

/*
 * Add a list of defaults structures to the defaults list.
 * The binding, if non-NULL, specifies a list of hosts, users, or
 * runas users the entries apply to (specified by the type).
 */
static void
add_defaults(int type, struct member *bmem, struct defaults *defs)
{
    struct defaults *d;
    struct member_list binding;
    debug_decl(add_defaults, SUDO_DEBUG_PARSER)

    /*
     * We can only call list2tq once on bmem as it will zero
     * out the prev pointer when it consumes bmem.
     */
    list2tq(&binding, bmem);

    /*
     * Set type and binding (who it applies to) for new entries.
     */
    for (d = defs; d != NULL; d = d->next) {
	d->type = type;
	d->binding = binding;
    }
    tq_append(&defaults, defs);

    debug_return;
}

/*
 * Allocate a new struct userspec, populate it, and insert it at the
 * and of the userspecs list.
 */
static void
add_userspec(struct member *members, struct privilege *privs)
{
    struct userspec *u;
    debug_decl(add_userspec, SUDO_DEBUG_PARSER)

    u = ecalloc(1, sizeof(*u));
    list2tq(&u->users, members);
    list2tq(&u->privileges, privs);
    u->prev = u;
    /* u->next = NULL; */
    tq_append(&userspecs, u);

    debug_return;
}

/*
 * Free up space used by data structures from a previous parser run and sets
 * the current sudoers file to path.
 */
void
init_parser(const char *path, bool quiet)
{
    struct defaults *d;
    struct member *m, *binding;
    struct userspec *us;
    struct privilege *priv;
    struct cmndspec *cs;
    struct sudo_command *c;
    debug_decl(init_parser, SUDO_DEBUG_PARSER)

    while ((us = tq_pop(&userspecs)) != NULL) {
	while ((m = tq_pop(&us->users)) != NULL) {
	    efree(m->name);
	    efree(m);
	}
	while ((priv = tq_pop(&us->privileges)) != NULL) {
	    struct member *runasuser = NULL, *runasgroup = NULL;
#ifdef HAVE_SELINUX
	    char *role = NULL, *type = NULL;
#endif /* HAVE_SELINUX */
#ifdef HAVE_PRIV_SET
	    char *privs = NULL, *limitprivs = NULL;
#endif /* HAVE_PRIV_SET */

	    while ((m = tq_pop(&priv->hostlist)) != NULL) {
		efree(m->name);
		efree(m);
	    }
	    while ((cs = tq_pop(&priv->cmndlist)) != NULL) {
#ifdef HAVE_SELINUX
		/* Only free the first instance of a role/type. */
		if (cs->role != role) {
		    role = cs->role;
		    efree(cs->role);
		}
		if (cs->type != type) {
		    type = cs->type;
		    efree(cs->type);
		}
#endif /* HAVE_SELINUX */
#ifdef HAVE_PRIV_SET
		/* Only free the first instance of privs/limitprivs. */
		if (cs->privs != privs) {
		    privs = cs->privs;
		    efree(cs->privs);
		}
		if (cs->limitprivs != limitprivs) {
		    limitprivs = cs->limitprivs;
		    efree(cs->limitprivs);
		}
#endif /* HAVE_PRIV_SET */
		if (tq_last(&cs->runasuserlist) != runasuser) {
		    runasuser = tq_last(&cs->runasuserlist);
		    while ((m = tq_pop(&cs->runasuserlist)) != NULL) {
			efree(m->name);
			efree(m);
		    }
		}
		if (tq_last(&cs->runasgrouplist) != runasgroup) {
		    runasgroup = tq_last(&cs->runasgrouplist);
		    while ((m = tq_pop(&cs->runasgrouplist)) != NULL) {
			efree(m->name);
			efree(m);
		    }
		}
		if (cs->cmnd->type == COMMAND) {
			c = (struct sudo_command *) cs->cmnd->name;
			efree(c->cmnd);
			efree(c->args);
		}
		efree(cs->cmnd->name);
		efree(cs->cmnd);
		efree(cs);
	    }
	    efree(priv);
	}
	efree(us);
    }
    tq_init(&userspecs);

    binding = NULL;
    while ((d = tq_pop(&defaults)) != NULL) {
	if (tq_last(&d->binding) != binding) {
	    binding = tq_last(&d->binding);
	    while ((m = tq_pop(&d->binding)) != NULL) {
		if (m->type == COMMAND) {
			c = (struct sudo_command *) m->name;
			efree(c->cmnd);
			efree(c->args);
		}
		efree(m->name);
		efree(m);
	    }
	}
	efree(d->var);
	efree(d->val);
	efree(d);
    }
    tq_init(&defaults);

    init_aliases();

    init_lexer();

    efree(sudoers);
    sudoers = path ? estrdup(path) : NULL;

    parse_error = false;
    errorlineno = -1;
    errorfile = sudoers;
    sudoers_warnings = !quiet;

    debug_return;
}
